{ Author: TGGC (http://pc.exit.de/tggc)}
uses crt;

Type pdata = ^Data;

     data  = Record
           text:   String;
           prev:   pdata;
           End;

var
   textStack:pdata;


Procedure Push (var text:String; Var top : pdata);
var pdataNew:pData;
begin
     getmem(pdataNew,sizeof(data));
     pdataNew^.prev:= top;
     pdataNew^.text:= text;
     top := pdataNew;
end;


Procedure Pop (Var top : pdata);
var pdataLast:pData;
begin
     if top <> Nil then begin
        pdataLast := top;
        top := top^.prev;
        freemem(pdataLast,sizeof(data));
     end;
end;


Procedure printstack;
begin
     while (textStack <> Nil) do begin
           writeln(textStack^.text);
           if textStack^.text='' then readkey;
           pop(textStack);
     end;
end;

Procedure fillstack;
var
   f:text;
   text:String;
begin
     writeln('Filename?');
     readln(text);
     assign(f, text);
     reset(f);
     while not Eof(f) do  begin
           readln(f,text);
           push(text,textStack);
     end;

     close(f);
end;

begin
     textStack:=nil;

     fillstack;

     printstack;

     readln;
end.